# -*- coding: utf-8 -*-
"""
Created on Fri Aug 26 11:51:46 2022

@author: Guenole

take the very simple network generated by "create_test_network"
Power and cost are modified to illustrate different behavior and check if everything work as expected.
"""
# Standard libraries
import pandapower as pp
import numpy as np
# Custom import
import code_these.dimension_reduction.tests.create_test_network as create_test_network


###################################################################################
##################### Creation of a big variety of set points #####################
###################################################################################

def net_a0():
    net = net = create_test_network.main(net_type="LMP")
    net.load.min_p_mw = [0,0,0,0,0,0,0,0]
    net.load.max_p_mw = [0.1,0.05,0.1,0.05,0.1,0.05,0.1,0.05,]
    net.ext_grid.min_p_mw = [0, np.nan]
    net.ext_grid.max_p_mw = [np.nan, 0]
    net.gen.min_p_mw = [0,0,0,0]
    net.gen.max_p_mw = [0.5, 1, 0.05, 0.01]
    
    net.poly_cost.cp1_eur_per_mw = [ 100,  80,
                                    -101, -1000, -100, -1000, -90, -1000, -90, -80,
                                    40, 50, 60, 10]
    net.poly_cost.cp2_eur_per_mw2 = [ 100,  80,
                                    -101, -1000, -100, -1000, -90, -1000, -90, -80,
                                    40, 50, 60, 10]
    return net

def net_b0():
    net = create_test_network.main()
    net.load.min_p_mw = [0,0,0,0,0]
    net.load.max_p_mw = [20,20,30,50,50]
    net.ext_grid.min_p_mw = [0, np.nan]
    net.ext_grid.max_p_mw = [np.nan, 0]
    net.gen.min_p_mw = [0,0]
    net.gen.max_p_mw = [80, 200]
    
    net.poly_cost.cp1_eur_per_mw = [ -99,  -99, -990, -101, -80, 100, 80, 65, 20]
    net.poly_cost.cp2_eur_per_mw2 = [-4950, -4950, -49500, -505, -400, 100, 80, 65, 20]
    
    return net


###################################################################################
###################### Main function : execution of the code ######################
###################################################################################

def main():
    net = net_a0()
    return net
    
if __name__=="__main__":
    net = main()
    